> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.getcompletedorrefundedorders.md).

# IAP.getCompletedOrRefundedOrders

### 功能说明

获取通过应用内购买购买或已退款的订单列表。

响应中的 `hasNext` / `nextKey`通过它可以知道是否有下一页。Web SDK 不接收参数，总是获取第一页。

Toss App Android/iOS `5.231.0` 及以上版本可使用。在不支持的版本中调用时 `UNSUPPORTED_APP_VERSION` 会发生错误。

### 类型

```ts
IAP.getCompletedOrRefundedOrders(): Promise<CompletedOrRefundedOrdersResult>;
```

**参数**

无

**响应**

```ts
type CompletedOrRefundedOrdersResult = {
  hasNext: boolean;
  nextKey?: string | null;
  orders: Array<{
    orderId: string;
    sku: string;
    status: "COMPLETED" | "REFUNDED";
    /** ISO 8601（例如：2025-09-22T00:00:00） */
    date: string;
  }>;
};
```

### 错误

错误代码是 catch 到的错误的 `error.code` 值。

| 代码                        | 说明                                                                                                                              |
| ------------------------- | ------------------------------------------------------------------------------------------------------------------------------- |
| `UNSUPPORTED_APP_VERSION` | 如果当前运行的 Toss App 版本不支持此功能，则调用后会立即发生。 `IAP.getCompletedOrRefundedOrders.isSupported()`请先通过它确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { IAP } from "@apps-in-toss/web-framework";

try {
  const response = await IAP.getCompletedOrRefundedOrders();
  console.log(response.orders);
} catch (error) {
  console.error(error);
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.getcompletedorrefundedorders.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
